{% from "nova/map.jinja" import controller with context %}

{%- set should_run = '/bin/false' %}
{%- if not grains.get('noservices') and controller.version not in ["juno", "kilo", "liberty"] and controller.get('role', 'primary') == 'primary' %}
{%- set should_run = '/bin/true' %}
{%- endif %}
{%- if controller.get('db_migrations', {}).max_count is defined %}
{%-   set batches = " --max-count %s" % controller.db_migrations.max_count %}
{%- else %}
{%-   set batches = "" %}
{%- endif %}

nova_controller_online_data_migrations:
  cmd.run:
  - name: nova-manage db online_data_migrations{{ batches }}
  - onlyif: {{ should_run }}
  - runas: 'nova'
